#include <stdlib.h>
#include <math.h>

typedef struct ViCToR 
{
	float x;
	float y;
	float z;
	float t;
} ViCToR;

//do void type of most function

//========================================================================
//=======================primitive========================================
//========================================================================

ViCToR * ViCToR_create(ViCToR * ViCToR_a)
{
	if (ViCToR_a == NULL)
	{
		ViCToR_a = malloc(sizeof(ViCToR));
	}
	return ViCToR_a;
}

ViCToR * ViCToR_delete(ViCToR * ViCToR_a)
{
	if (ViCToR_a != NULL)
	{
		free(ViCToR_a);
		return NULL;
	}
	return NULL;
}

void ViCToR_set(ViCToR * ViCToR_a, float ViCToR_x, float ViCToR_y) 
{
	ViCToR_a->x = ViCToR_x;
	ViCToR_a->y = ViCToR_y;
	//ViCToR_a->z = ViCToR_z;
	//ViCToR_a->t = ViCToR_t;
	return;
}

void ViCToR_cpy(ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	mov va,vb	*/
{
	ViCToR_a->x = ViCToR_b->x;
	ViCToR_a->y = ViCToR_b->y;
	//ViCToR_a->z = ViCToR_b->z;
	//ViCToR_a->t = ViCToR_b->t;
	return;
}

//========================================================================
//========================math============================================
//========================================================================

void ViCToR_sub(ViCToR * ViCToR_c, ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	sub va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x - ViCToR_b->x;          
	ViCToR_c->y = ViCToR_a->y - ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z - ViCToR_b->z;
	//ViCToR_c->t = ViCToR_a->t - ViCToR_b->t;
	return;
}

void ViCToR_add(ViCToR * ViCToR_c, ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	add va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x + ViCToR_b->x;         
	ViCToR_c->y = ViCToR_a->y + ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z + ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t + ViCToR_b->t;
	return;
}

void ViCToR_mul(ViCToR * ViCToR_c, ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	mul va,vb	*/
{
 	ViCToR_c->x = ViCToR_a->x * ViCToR_b->x;         
	ViCToR_c->y = ViCToR_a->y * ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z * ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t * ViCToR_b->t;
	return;
}

void ViCToR_div(ViCToR * ViCToR_c, ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	div va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x / ViCToR_b->x;
	ViCToR_c->y = ViCToR_a->y / ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z / ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t / ViCToR_b->t;
	return;
}

void ViCToR_neg(ViCToR * ViCToR_c, ViCToR * ViCToR_a)
	/*	-va	*/
{
	ViCToR_c->x = 0-ViCToR_a->x;                 
	ViCToR_c->y = 0-ViCToR_a->y;
	//ViCToR_c->z = 0-ViCToR_a->z;                 
	//ViCToR_c->t = 0-ViCToR_a->t;
	return;
}

//========================================================================
